use ContosoRetailDW;

dbcc freeproccache;
dbcc dropcleanbuffers;
set statistics io on
set statistics time on

select prod.ProductName, sum(sales.SalesAmount) as SoldAmount
	from dbo.FactOnlineSales sales
		inner join dbo.DimProduct prod
			on sales.ProductKey = prod.ProductKey
		inner join dbo.DimCurrency cur
			on sales.CurrencyKey = cur.CurrencyKey
		inner join dbo.DimPromotion prom
			on sales.PromotionKey = prom.PromotionKey
		inner join dbo.DimCustomer cust
			on sales.CustomerKey = cust.CustomerKey
	where (cur.CurrencyName = 'USD' or cur.CurrencyName = 'EUR') 
		and prom.EndDate >= '2004-01-01' and cust.BirthDate < '1980-01-01'
	group by prod.ProductName
	order by sum(sales.SalesAmount) desc;

-- CPU time = 344 ms,  elapsed time = 248 ms.

dbcc freeproccache;
dbcc dropcleanbuffers;

select prod.ProductName, sum(sales.SalesAmount) as SoldAmount
	from dbo.FactOnlineSales sales
		inner join dbo.DimProduct prod
			on sales.ProductKey = prod.ProductKey
		inner join dbo.DimCurrency cur
			on sales.CurrencyKey = cur.CurrencyKey
		inner join dbo.DimPromotion prom
			on sales.PromotionKey = prom.PromotionKey
		inner join dbo.DimCustomer cust
			on sales.CustomerKey = cust.CustomerKey
	where (cur.CurrencyName = 'USD' or cur.CurrencyName = 'EUR') 
		and prom.EndDate >= '2004-01-01' and cust.BirthDate < '1980-01-01'
	group by prod.ProductName
	order by sum(sales.SalesAmount) desc


--   CPU time = 7810 ms,  elapsed time = 2267 ms.





	option (queryruleoff EnforceRow);