/* 
 * Queries for testing SQL Server 2014 Columnstore improvements
 * by Niko Neugebauer (http://www.nikoport.com)
 *
 * This queries demonstrate the current status of the RowGroups
 */

-- Check on the Row Groups status
SELECT object_name(i.object_id) AS TableName
		, count(*) as RowGroupCount
	FROM sys.indexes AS i
	INNEr JOIN sys.column_store_row_groups AS rg
		ON i.object_id = rg.object_id
	AND i.index_id = rg.index_id 
	--WHERE object_name(i.object_id) = '<table_name>' 
	group by object_name(i.object_id) 
	ORDER BY object_name(i.object_id)--, i.name, row_group_id;

-- **************************************************************************
dbcc freeproccache 

exec sp_configure 'max server memory (MB)', '512';
reconfigure

-- Rebuild Sample Table
alter table [dbo].[FactOnlineSales]
	rebuild 

-- Check on the Row Groups status
SELECT object_name(i.object_id) AS TableName
		, count(*) as RowGroupCount
	FROM sys.indexes AS i
	INNEr JOIN sys.column_store_row_groups AS rg
		ON i.object_id = rg.object_id
	AND i.index_id = rg.index_id 
	--WHERE object_name(i.object_id) = '<table_name>' 
	group by object_name(i.object_id) 
	ORDER BY object_name(i.object_id)--, i.name, row_group_id;

-- Check on the Row Groups status
SELECT total_rows, size_in_bytes, object_name(rg.object_id) as TableName, state, state_description
	FROM sys.indexes AS i
	INNEr JOIN sys.column_store_row_groups AS rg
		ON i.object_id = rg.object_id
	AND i.index_id = rg.index_id 
	--WHERE object_name(i.object_id) = '<table_name>' 
	--group by object_name(i.object_id) 
	ORDER BY object_name(i.object_id)--, i.name, row_group_id;

exec sp_configure 'max server memory (MB)', '8192';
reconfigure

-- Rebuild it
alter table [dbo].[FactOnlineSales]
	rebuild;

-- Check on the Row Groups status
SELECT object_name(i.object_id) AS TableName
		, count(*) as RowGroupCount
	FROM sys.indexes AS i
	INNEr JOIN sys.column_store_row_groups AS rg
		ON i.object_id = rg.object_id
	AND i.index_id = rg.index_id 
	--WHERE object_name(i.object_id) = '<table_name>' 
	group by object_name(i.object_id) 
	ORDER BY object_name(i.object_id)--, i.name, row_group_id;

-- Check on the Row Groups status
SELECT total_rows, size_in_bytes, object_name(rg.object_id) as TableName, state, state_description
	FROM sys.indexes AS i
	INNEr JOIN sys.column_store_row_groups AS rg
		ON i.object_id = rg.object_id
	AND i.index_id = rg.index_id 
	--WHERE object_name(i.object_id) = '<table_name>' 
	--group by object_name(i.object_id) 
	ORDER BY object_name(i.object_id)--, i.name, row_group_id;

